package com.huimv.admin.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.admin.common.utils.Result;
import com.huimv.admin.common.utils.ResultCode;
import com.huimv.admin.entity.EnvDayagePeizhi;
import com.huimv.admin.entity.EnvFengPeizhi;
import com.huimv.admin.mapper.EnvFengPeizhiMapper;
import com.huimv.admin.service.IEnvFengPeizhiService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author author
 * @since 2023-04-10
 */
@Service
public class EnvFengPeizhiServiceImpl extends ServiceImpl<EnvFengPeizhiMapper, EnvFengPeizhi> implements IEnvFengPeizhiService {

    @Resource
    private EnvFengPeizhiMapper envFengPeizhiMapper;

    @Override
    public Result listWind(Map<String, String> paramsMap) {
        String deviceCode = paramsMap.get("deviceCode");
        String timeFeng = paramsMap.get("timeFeng");
        List<EnvFengPeizhi> envDayFengPeizhis = envFengPeizhiMapper.selectList(new QueryWrapper<EnvFengPeizhi>()
                .eq("device_code", deviceCode)
                .eq("time_feng", timeFeng)
                .orderByAsc("level_feng"));
        List list = new ArrayList();
        for (EnvFengPeizhi envDayFengPeizhi : envDayFengPeizhis) {
            Map map = new HashMap();
            map.put("level","M"+envDayFengPeizhi.getLevelFeng());
            map.put("tempGap",envDayFengPeizhi.getTempDiff());
            List detailList = new ArrayList();
            map.put("detail",detailList);
            String fans = envDayFengPeizhi.getFansCtrl();
            int j = 1;
            for (int i = fans.length()-1; i >= 0; i--) {
                Map detailMap = new HashMap();
                detailMap.put("name","风机"+j);
                detailMap.put("status",fans.charAt(i));
                if (fans.charAt(i) == '0'){
                    detailMap.put("constantSpeed",0);
                    detailMap.put("timeControl",0);
                    detailMap.put("changeSpeed",0);
                    detailMap.put("speed",0);
                    detailMap.put("openTime",0);
                    detailMap.put("stopTime",0);
                }else {
                    detailMap.put("constantSpeed",envDayFengPeizhi.getFanEnable());
                    detailMap.put("timeControl",envDayFengPeizhi.getCycleMode());
                    detailMap.put("changeSpeed",envDayFengPeizhi.getVarFanEnable());
                    detailMap.put("speed",envDayFengPeizhi.getSpeed());
                    detailMap.put("openTime",envDayFengPeizhi.getRunGap());
                    detailMap.put("stopTime",envDayFengPeizhi.getStopGap());
                }
                detailList.add(detailMap);
                j++;
            }
            list.add(map);
        }
        return new Result(ResultCode.SUCCESS,list);
    }
}
