package com.huimv.admin.timer;

import cn.hutool.core.date.DateUnit;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.admin.common.utils.DataUill;
import com.huimv.admin.entity.EnvDevice;
import com.huimv.admin.entity.EnvDeviceOnline;
import com.huimv.admin.entity.vo.EnvDeviceOnlineVo;
import com.huimv.admin.service.IEnvDeviceOnlineService;
import com.huimv.admin.service.IEnvDeviceService;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.time.LocalDateTime;
import java.util.Date;

@Configuration
@EnableScheduling
public class DeviceTimer {

    @Resource
    private IEnvDeviceService envDeviceService;
    @Resource
    private IEnvDeviceOnlineService envDeviceOnlineService;

    @Scheduled(cron = "0 */5 * * * ?")
//    @Scheduled(cron = "*/5 * * * * ?")
    private void saveOnlineDevice(){
        String farmId = "27";
        double rate = 0.0;
        Integer deviceOff = envDeviceService.count(new QueryWrapper<EnvDevice>().eq("farm_id", farmId).eq("device_status", 0));
        Integer deviceOn = envDeviceService.count(new QueryWrapper<EnvDevice>().eq("farm_id", farmId).eq("device_status", 1));
        Integer total = deviceOff+deviceOn;
        LocalDateTime now = LocalDateTime.now();
        try {
            rate = (deviceOn/total)*100;
        }catch (ArithmeticException e){
            System.out.println(e);
        }
        EnvDeviceOnline envDeviceOnline = new EnvDeviceOnline();
        envDeviceOnline.setDeviceOn(deviceOn);
        envDeviceOnline.setDeviceOff(deviceOff);
        envDeviceOnline.setOnlineRate(new BigDecimal(rate).setScale(2, RoundingMode.UP));
        envDeviceOnline.setFarmId(farmId);
        envDeviceOnline.setCreatTime(now);
        envDeviceOnlineService.save(envDeviceOnline);
    }
}
